﻿package {
	import flash.display.MovieClip;
	import flash.display.DisplayObject;
	import flash.display.BitmapData;
	import flash.display.IBitmapDrawable;
	import flash.display.BitmapDataChannel;
	import flash.filters.DisplacementMapFilter;
	import flash.geom.Point;
	import flash.events.Event;


	public class pred_as3 extends MovieClip {
		
		private var clipcont= new Array();// all the animated frames are stored in this array
		
		private var count:Number; //part of the enterframe loop; tells which frame of animation is being shown
		private var timer:uint = 0;
		public var displ_mc:MovieClip;
		public var bkgd_mc:MovieClip;	
		
		private var spe:int = 1;
		private var strength1:int = 120; // sets the intensity of the displacement filter
		private var mapBitmap:BitmapData = new BitmapData(320,240);// the size of the displacement map in pixels
		
		private var mapPoint:Point = new Point(0,0);// the position of the displacement bitmap
		private var componentX = BitmapDataChannel.GREEN;// which color channel is used; doesn't really matter since it's in shades of gray;
		private var componentY = BitmapDataChannel.GREEN;

		//all variables are then applied to a new filter
		private var filter:DisplacementMapFilter = new DisplacementMapFilter(mapBitmap, mapPoint, componentX, componentY, scaleX, scaleY);
		
		private var filterList = new Array();//  a filter list array.

		//CLASS CONSTRUCTOR
		public function pred_as3() {
			addChild(displ_mc);
			addChild(bkgd_mc); // add both Movie Clip instances to the stage
			storeClips();
			
			filterList.push(filter);// add the displacement map filter to the array.

			bkgd_mc.filters = filterList; // applies the set of filters to the target movie clip.
			addEventListener(Event.ENTER_FRAME, animate);
		}

		private function storeClips():void //stores the animation in an array
		{
			count = displ_mc.numChildren;
			
			for (var i:int = 0; i < displ_mc.numChildren; i++)
			{
					clipcont.push(displ_mc.getChildAt(i));
			}
		}

		private function animate(e:Event) {  
			filter.scaleY = strength1; 
			filter.scaleX = strength1;
			
			timer++;
		
			if(timer > 3) // a new frame is drawn every 4 frames
			{
				if(count <= 0)
				{
					count = clipcont.length;// setting an infinite loop
				}
				count--;
				timer = 0;
			}
			
			if (clipcont[count])
			{
				filter.mapBitmap.draw(clipcont[count]);// a new frame of animation is drawn
			}
			
			if (filter.scaleX > 220 || filter.scaleX < 120) // filter keeps changing it's intensity, making the effect more dynamic
			{
				spe *= -1;
			}
			strength1 += spe;
			
			filter.mapPoint = new Point(mouseX-160, mouseY-240);  //  displacement map follows the mouse
			bkgd_mc.filters = filterList;
		 }  
	}
}